import Parser = require('./Parser');
/**
 * Class holding options for Twitter
 * This class should only be used
 * while parsing DSL code
 * 
 * 
 * @class TwitterOpts
 */
class TwitterOpts {
    private _consumerKey: string;
    private _consumerKeySecret: string;
    private _token: string;
    private _tokenSecret: string;

    set consumerKey(str: string) {
        this._consumerKey = str;
    }

    get consumerKey(): string {
        return this._consumerKey;
    }

    set consumerSecretKey(str: string) {
        this._consumerKeySecret = str;
    }

    get consumerSecretKey() {
        return this._consumerKeySecret;
    }

    set token(str: string) {
        this._token = str;
    }

    get token() {
        return this._token;
    }

    set tokenSecret(str: string) {
        this._tokenSecret = str;
    }

    get tokenSecret() {
        return this._tokenSecret;
    }


    /**
     * Whether all required is set for the twitter object to 
     * be ready for usage
     * 
     * @readonly
     * @type {boolean}
     */
    get isReady(): boolean {
        return this._consumerKey != null && this._consumerKeySecret != null && this._token != null && this._tokenSecret != null;
    }

    get write(): string {
        return "dsl.initTwitter(\'" + this.consumerKey + "\',\'" + this.consumerSecretKey + "\',\'" + this.token + "\',\'" + this.tokenSecret + "\');";
    }

}

export = TwitterOpts;