import MqttClient = require('../../MqttClient');
import Tile = require('../../User/Tile');
import LedCommand = require('../LedCommand');

class LedController {
    private mqtt: MqttClient = null;

    public constructor(mqtt: MqttClient) {
        this.mqtt = mqtt;
    }

    public turnOn(tile: Tile) {
        this.mqtt.sendCommand(tile, LedCommand.turnOn);
    }

    public turnOff(tile: Tile) {
        this.mqtt.sendCommand(tile, LedCommand.turnOff);
    }

    public blink(tile: Tile) {
        this.mqtt.sendCommand(tile, LedCommand.blink);
    }

    public fade(tile: Tile) {
        this.mqtt.sendCommand(tile, LedCommand.fade);
    }
}

export = LedController;