import MqttClient = require('../../MqttClient');
import Tile = require('../../User/Tile');
import SpeakerCommand = require('../SpeakerCommand');

class SpeakerController {
    private mqtt: MqttClient = null;

    public constructor(mqtt: MqttClient) {
        this.mqtt = mqtt;
    }

    public play(tile: Tile) {
        this.mqtt.sendCommand(tile, SpeakerCommand.play);
    }

    public stop(tile: Tile) {
        this.mqtt.sendCommand(tile, SpeakerCommand.stop);
    }
}

export = SpeakerController;