import iFilter = require('./iFilter');
import Event = require('../../../Event');
import Tile = require('../User/Tile');

class EventFilter implements iFilter {
    status: boolean;

    private event: Event;
    private tile: Tile;

    public constructor(tile: Tile, event: Event) {
        this.event = event;
        this.tile = tile;
        this.status = false;
    }

    public run(data: { event: Event, tile: Tile }): boolean {
        if (this.status || (data.event.name == this.event.name && (this.event.event==null || data.event.event == this.event.event) && data.tile.id == this.tile.id)) {
            this.status = true;
            return true;
        }
        return false;
    }
}

export = EventFilter;