export interface iPost {
    story?: string, //Facebook status (events occured)
    message?: string, //messages posted by others
    created_time: string, //2016-02-10T09:50:34+0000
    id: string
}

export interface iFeed {
    story?: string, //Facebook status (events occured)
    message?: string, //messages posted by others
    created_time: string, //2016-02-10T09:50:34+0000
    id: string
}

export interface iFamily {
    name: string, //name of family member
    id: string,//user id
    relationship: string //type of family relationship
}

export interface iLike {
    name: string,//name of like (page, movie, ANYTHING)
    id: string,
    created_time: string // 2016-02-10T09:50:34+0000
}


export interface iTaggedPlaces {
    id: string,
    created_time: string,// 2016-02-10T09:50:34+0000
    place: {
        id: string, //id place
        location: {//coordinates of place
            latitude: number,
            longitude: number
        },
        name: string //location name
    }
}

//the general result structure of a facebook response
export interface iResult<T> {
    data: Array<T>,
    paging: {
        cursor: {
            before: string,
            after: string
        }
        previous?: string,//url
        next?: string,//url
    }
}




//new post
export interface iNewFeed {
    message: string,//The main body of the post, otherwise called the status message
    link?: string | { //the URL of a link to attach to the post
        picture: string,//Determines the preview image associated with the link.
        name: string,//Overwrites the title of the link preview
        caption: string, //Overwrites the caption under the title in the link preview
        description: string //Overwrites the description in the link preview
    },
    place?: string, //Page ID of a location associated with this pos
    tags?: string, //csv (comma separated) list of user IDs of people tagged in this post
    privacy?: {//Determines the privacy settings of the pos
        value?: "EVERYONE" | "ALL_FRIENDS" | "FRIENDS_OF_FRIENDS" | "CUSTOM" | "SELF",
        allow?: string, //csv (comma separated) list of user ids that can see post
        deny?: string //csv (comma separated) list of user ids that can NOT see post
    },
    object_attachment?: string //Facebook ID for an existing picture in the person's photo albums to use as the thumbnail image
}