import iWeatherInterfaces = require('./iWeatherInterfaces');

class ForecastWeather {
    private weather: iWeatherInterfaces.iForecastWeather;

    public constructor(weather: iWeatherInterfaces.iForecastWeather) {
        this.weather = weather;
    }

    // number of list result (size of list array)
    get numbOfResult(): number {
        return this.weather.cnt;
    }

    get cityId(): number {
        return this.weather.city.id;
    }

    get cityName(): string {
        return this.weather.city.name;
    }

    public getWeatherInfo(i: number = 0) {
        if (i < 0 || i > this.numbOfResult)
            return null;
        return this.weather.list[i];
    }

    get avgTemp(): number {
        var avg = 0;
        this.weather.list.forEach(function (value, key) {
            avg += value.main.temp;
        });

        return avg / this.numbOfResult;
    }

    get avgMaxTemp(): number {
        var avg = 0;
        this.weather.list.forEach(function (value, key) {
            avg += value.main.temp_max;
        });

        return avg / this.numbOfResult;
    }

    get avgMinTemp(): number {
        var avg = 0;
        this.weather.list.forEach(function (value, key) {
            avg += value.main.temp_min;
        });

        return avg / this.numbOfResult;
    }
}

export = ForecastWeather;