import Config = require('./Config');

const ANIMATION_END_EVENTS: Array<string> = ["webkitAnimationEnd", "mozAnimationEnd", "MSAnimationEnd", "oanimationend", "animationend"];
const ANIMATION_CLASS = "animated";

class Animator {
    public static tempDom: Element = null;
    public static tempAnimation: Config.Animation = null;
    public static tempFunc: Function = null;

    public static animate(dom: Element, animation: Config.Animation, after: Function = null) {

        this.tempDom = dom;
        this.tempAnimation = animation;
        this.tempFunc = after;

        console.log("CLASSNAME:", dom.className);



        ANIMATION_END_EVENTS.forEach(function (event) {
            console.log("adding event..", event, dom);
            dom.addEventListener(event, Animator.animationListener);
        });

        dom.classList.toggle(ANIMATION_CLASS);
        dom.classList.toggle(animation);

        console.log("CLASSNAME:", dom.className);
    }

    public static animationListener() {
        Animator.tempDom.classList.remove(ANIMATION_CLASS);
        Animator.tempDom.classList.remove(Animator.tempAnimation);

        if (Animator.tempFunc != null)
            Animator.tempFunc();

        ANIMATION_END_EVENTS.forEach(function (event) {
            console.log("REMOVING EVENT", event)
            Animator.tempDom.removeEventListener(event, Animator.animationListener);
        })

        Animator.tempDom = null;
        Animator.tempAnimation = null;
        Animator.tempFunc = null;
    }
}

export = Animator;
