import iOutput = require('./iOutput');
import Command = require('../../../Command');

class Speaker implements iOutput {
    private dom: Element = null;
    private active: boolean = false;
    private timer = null;
    private command: Command = null;
    private isPlaying: boolean = false;

    public constructor(dom: Element, active: boolean = false) {
        this.dom = dom;
        this.active = active;
    }

    private toggle() {
        if (this.active)
            this.dom.classList.add("active");
        else
            this.dom.classList.remove("active");
    }

    /**
     * Parse a command and act accordingly
     * 
     * @param {iCommand} command to parse and trigger correct function
     * @returns {boolean} whether command was parsed
     */
    public parse(command: Command): boolean {
        this.command = command;
        this.active = (this.command.event == "start") ? true : false;

        switch (this.command.event) {
            case "start":
            case "stop":
            case "pause":
                this.toggle();
                break;
        }

        return false;
    }
}

export = Speaker;
