import iOutput = require('./iOutput');
import Command = require('../../../Command');
import Animator = require('../Animator');

class Vibrate implements iOutput {
    private dom: Element = null;
    private active: boolean = false;
    private timer = null;
    private command: Command = null;

    public constructor(dom: Element, active: boolean = false) {
        this.dom = dom;
        this.active = active;
    }

    private vibrate() {
        if (this.active) {
            var self = this;
            //vibrate
            this.dom.classList.add("active");
            Animator.animate(this.dom.firstElementChild.firstElementChild, "shake", function () {
                self.dom.classList.remove("active");
            });
        }
    }

    /**
     * Parse a command and act accordingly
     * 
     * @param {iCommand} command to parse and trigger correct function
     * @returns {boolean} whether command was parsed
     */
    public parse(command: Command): boolean {

        this.command = command;
        // console.log("input command", this.command);
        //this.active = (command.activation == "on") ? true : false;
        this.active = true;

        switch (this.command.event) {
            case "long":
            case "burst":
                this.vibrate();
                break;
        }

        return false;
    }
}

export = Vibrate;