import TextualEditorController = require('./TextualEditorController');
/**
 * Class defining routes made available
 * for the Textual Module
 * 
 * @class TextualRoute
 * @extends {Spa.Route}
 */
class TextualRoute extends Spa.Route {

    /**
     * Creates an instance of TextualRoute.
     * 
     * @param {string} route the url which the route should be made accessible
     */
    constructor(route: string) {
        super(route);
        this.setRouteTitle("Textual");
    }

    /**
     * Initializes all routes
     */
    initRoutes() {
        var parent = this;

        super.addRoute('/', function () {
            parent.render("textual/index");
            //TODO: add controller

        });

        super.addRoute('/editor', function () {
            parent.render('textual/editor');
            new TextualEditorController();
        });
    }
}

export = TextualRoute;