import Interfaces = require('./Interfaces');
declare var Data: any;

class TileApi {

    private client: Spa.Rest = null;

    public constructor(username: string) {
        this.client = new Spa.Rest(Data.config.tileapi + "/users/" + username);
    }

    public getTiles(func: (tiles: Array<Object>) => void) {
        this.client.get("/tiles", null, function (tiles: Array<Interfaces.TileReq>) {

            var returnTiles = Array<Object>();

            tiles.forEach(function (tile: Interfaces.TileReq) {
                returnTiles.push({ id: tile._id, name: tile.name });
            });

            func(returnTiles);
        });
    }

    public getTile(id: string, func: Function) {
        this.client.get("/tiles/" + id, null, function (tile: Interfaces.TileReq) {
            func({ id: tile._id, name: tile.name });
        });
    }

    public startApp(name: string, code: string, func: (status: boolean, message: string) => void) {
        this.client.post("/application/" + name, JSON.stringify({ code: code }), function (response: { success: boolean, message: string }) {
            func(response.success, response.message);
        });
    }

    public stopApp(name: string, func: (status: boolean, message: string) => void) {
        this.client.delete("/application/" + name, null, function (response: { success: boolean, message: string }) {
            func(response.success, response.message);
        });
    }
}

export = TileApi;