import VisualEditorController = require('./VisualEditorController');
/**
 * Class defining routes made available
 * for the Visual Module
 * 
 * @class VisualRoute
 * @extends {Spa.Route}
 */
class VisualRoute extends Spa.Route {
    /**
     * Creates an instance of VisualRoute.
     * 
     * @param {string} route the url which the route should be made accessible
     */
    constructor(route: string) {
        super(route);
        this.setRouteTitle("Visual");
    }

    /**
     * Initializes all routes
     */
    initRoutes() {
        var parent = this;

        super.addRoute('/editor', function () {
            console.log("visual editor");
            parent.render("visual/editor");
            new VisualEditorController();
        });
    }
}

export = VisualRoute;