declare module 'tile' {

    type colors = "red" | "green" | "blue" | "white"

    type hapticEvent = "long" | "burst";
    type ledEvent = "blink" | "fade" | "on" | "off";
    type speakerEvent = "start" | "stop" | "pause";
    type commandEvents = hapticEvent | ledEvent | speakerEvent;
    type outputInterfaces = "led" | "speaker" | "haptic";

    export interface iCommand {
        name: outputInterfaces,
        event: hapticEvent | ledEvent | speakerEvent,
        param?: colors | string
    }


    type event = "single" | "double" | "touch_hold" | //TapEvent
        "left" | "right" | "updown" | //TileEvent
        "clockwise" | "anticlockwise" | //RotateEvent
        "horizontally" | "vertically" | //ShakeEvent
        "lift" | "freefall" | //VerticalShiftEvent
        "left" | "right" | "top" | "bottom" //ProximityEvent

    type eventNames = "tap" | "tilt" | "rotate" | "shake" | "vertical_shift" | "proximity";

    export interface iEvent {
        name: eventNames,
        event: event,
        param?: string
    }

    export interface Message {
        name: string,
        properties: Array<string>
    }





}